var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as PropTypes from 'prop-types';
import * as React from 'react';
import { executeMediaQuery, Media } from './Media';
import { MediaServerSide } from './SSR';
import { getMaxMatch, inBetween, nothingSet, notNulls, pickMatchValues, pickMediaMatch } from './utils';
var castPointsTo = function (points, targetType) {
    return Object.keys(points).reduce(function (acc, key) {
        acc[key] = targetType;
        return acc;
    }, {});
};
var skipProp = {};
// @ts-ignore
var use = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return null;
};
export function createMediaMatcher(queries, firstKey) {
    use(firstKey);
    var mediaDefaults = executeMediaQuery(queries);
    var initialValue = {};
    var MediaContext = React.createContext(initialValue);
    var getMediaMatches = function (matches) { return (matches === initialValue ? mediaDefaults : matches); };
    var consume = function (cb) { return (React.createElement(MediaContext.Consumer, null, function (matched) { return cb(getMediaMatches(matched)); })); };
    function pickMatch(matches, slots, defaultValue) {
        return pickMediaMatch(queries, matches, slots, defaultValue);
    }
    function useMedia(slots, defaultValue) {
        var matches = getMediaMatches(React.useContext(MediaContext));
        return pickMatch(matches, slots, defaultValue);
    }
    function pickMatchEx(matches, slots) {
        return pickMediaMatch(queries, matches, slots);
    }
    var ProvideMediaMatchers = function (_a) {
        var children = _a.children, _b = _a.state, state = _b === void 0 ? null : _b;
        return (React.createElement(MediaContext.Consumer, null, function (parentMatch) { return (React.createElement(Media, { queries: queries }, function (matches) {
            var value = state || __assign({}, notNulls(matches), (parentMatch || {}));
            return React.createElement(MediaContext.Provider, { value: value, children: children });
        })); }));
    };
    ProvideMediaMatchers.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? {
                state: PropTypes.shape(__assign({}, castPointsTo(queries, PropTypes.bool))),
            }
            : skipProp;
    var MediaMatches = function (_a) {
        var children = _a.children;
        return consume(function (matched) { return children(matched, function (matches) { return pickMatch(matched, matches); }); });
    };
    MediaMatches.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? {
                children: PropTypes.func.isRequired,
            }
            : skipProp;
    var InlineMediaMatcher = function (props) {
        return consume(function (matched) { return pickMatchEx(matched, props); });
    };
    var MediaMatcher = function (props) {
        return consume(function (matched) { return pickMatchEx(matched, props); });
    };
    MediaMatcher.propTypes =
        // @ts-ignore
        process.env.NODE_ENV !== 'production'
            ? __assign({}, castPointsTo(queries, PropTypes.node)) : skipProp;
    var Mock = function (_a) {
        var children = _a.children, props = __rest(_a, ["children"]);
        return (React.createElement(MediaContext.Provider, { value: pickMatchValues(queries, __assign({}, nothingSet(queries), props)) }, children));
    };
    var Override = function (_a) {
        var children = _a.children, props = __rest(_a, ["children"]);
        return (React.createElement(MediaContext.Consumer, null, function (parentMatch) {
            var value = __assign({}, notNulls(parentMatch), pickMatchValues(queries, props));
            return React.createElement(MediaContext.Provider, { value: value, children: children });
        }));
    };
    var Below = function (_a) {
        var children = _a.children, including = _a.including, props = __rest(_a, ["children", "including"]);
        return (React.createElement(MediaMatcher, __assign({}, inBetween(queries, props, children, including ? false : true, true))));
    };
    var Above = function (_a) {
        var children = _a.children, including = _a.including, props = __rest(_a, ["children", "including"]);
        return (React.createElement(MediaMatcher, __assign({}, inBetween(queries, props, children, including ? true : false, false))));
    };
    var ServerRender = function (_a) {
        var _b;
        var predicted = _a.predicted, hydrated = _a.hydrated, children = _a.children;
        return (React.createElement(MediaContext.Provider, { value: (_b = {}, _b[predicted] = true, _b) },
            React.createElement(ProvideMediaMatchers, null,
                React.createElement(MediaContext.Consumer, null, function (matched) { return (React.createElement(MediaServerSide, { fact: getMaxMatch(queries, matched), predicted: predicted, hydrated: !!hydrated, children: children })); }))));
    };
    return {
        pickMatch: pickMatch,
        useMedia: useMedia,
        Provider: ProvideMediaMatchers,
        Mock: Mock,
        Override: Override,
        //
        Matches: MediaMatches,
        Inline: InlineMediaMatcher,
        Above: Above,
        Below: Below,
        //
        Matcher: MediaMatcher,
        ServerRender: ServerRender,
        //
        Gearbox: MediaContext.Consumer,
        Consumer: MediaContext.Consumer,
    };
}
