import { createMediaMatcher } from './createMediaMatcher';
/**
 * Picks value from Slots for matching Match)
 * @type {<K>(matches: BoolOf<T>, slots: ObjectOf<T, K>) => K}
 */
declare const pickMatch: {
    <K>(matches: import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, boolean>, slots: import("./types").WithRequiredKeysSet<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>, "mobile">): K;
    <K>(matches: import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, boolean>, slots: Partial<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>>): K | undefined;
    <K, DK extends K = K>(matches: import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, boolean>, slots: Partial<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>>, defaultValue: DK): K;
};
/**
 * Provides Context for underlying consumers
 * @type {SFC}
 */
declare const ProvideMediaMatchers: import("react").FunctionComponent<{
    state?: import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, boolean> | undefined;
}>;
/**
 * Consumes provided information from context and returns via renderProps
 * @type {SFC<{children: RenderMatch<any>}>}
 */
declare const MediaMatches: import("./types").LeafComponent<{
    children: import("./types").RenderMatch<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, any>;
}>;
/**
 * Calculates media match and renders a rule
 * @type {SFC<RenderOf<any>>}
 */
declare const InlineMediaMatcher: import("./types").LeafComponent<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, import("react").ReactNode>>>;
/**
 * Consumes provided information and renders matched rule
 * @type {SFC<RenderOf<any>>}
 */
declare const MediaMatcher: import("./types").LeafComponent<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, import("react").ReactNode>>>;
/**
 * Calculates media match and returns via renderProps
 * @type {RPC<any, any>}
 */
declare const Matches: import("./types").LeafComponent<{
    children: import("./types").RenderMatch<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, any>;
}>;
declare const MediaMock: import("react").FunctionComponent<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, import("react").ReactNode>>>;
/**
 * Renders only below specific break point
 */
declare const Below: import("react").FunctionComponent<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, boolean>> & import("./types").Including>;
/**
 * Renders only above specific break point
 */
declare const Above: import("react").FunctionComponent<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, boolean>> & import("./types").Including>;
/**
 * ServerSide rendering helper
 */
declare const MediaServerRender: import("react").FunctionComponent<{
    predicted: "mobile" | "tablet" | "desktop";
    hydrated?: boolean | undefined;
    children: import("react").ReactNode;
}>;
declare const MediaConsumer: import("react").ExoticComponent<import("react").ConsumerProps<Partial<import("./types").ObjectOf<{
    'mobile': unknown;
    'tablet': unknown;
    'desktop': unknown;
}, boolean>>>>;
/**
 * pickMatchHookAPI
 */
declare const useMedia: {
    <K>(slots: import("./types").WithRequiredKeysSet<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>, "mobile">): K;
    <K>(slots: Partial<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>>): K | undefined;
    <K, DK extends K = K>(slots: Partial<import("./types").ObjectOf<{
        'mobile': unknown;
        'tablet': unknown;
        'desktop': unknown;
    }, K>>, defaultValue: DK): K;
};
export { createMediaMatcher, pickMatch, ProvideMediaMatchers, MediaMatches, InlineMediaMatcher, Above, Below, MediaMatcher, MediaServerRender, Matches, MediaMock, MediaConsumer, useMedia, };
