import { createMediaMatcher } from './createMediaMatcher';
import mediaDefaults from './mediaDefaults';
var defaultMedia = createMediaMatcher(mediaDefaults, 'mobile');
/**
 * Picks value from Slots for matching Match)
 * @type {<K>(matches: BoolOf<T>, slots: ObjectOf<T, K>) => K}
 */
var pickMatch = defaultMedia.pickMatch;
/**
 * Provides Context for underlying consumers
 * @type {SFC}
 */
var ProvideMediaMatchers = defaultMedia.Provider;
/**
 * Consumes provided information from context and returns via renderProps
 * @type {SFC<{children: RenderMatch<any>}>}
 */
var MediaMatches = defaultMedia.Matches;
/**
 * Calculates media match and renders a rule
 * @type {SFC<RenderOf<any>>}
 */
var InlineMediaMatcher = defaultMedia.Inline;
/**
 * Consumes provided information and renders matched rule
 * @type {SFC<RenderOf<any>>}
 */
var MediaMatcher = defaultMedia.Matcher;
/**
 * Calculates media match and returns via renderProps
 * @type {RPC<any, any>}
 */
var Matches = defaultMedia.Matches;
var MediaMock = defaultMedia.Mock;
/**
 * Renders only below specific break point
 */
var Below = defaultMedia.Below;
/**
 * Renders only above specific break point
 */
var Above = defaultMedia.Above;
/**
 * ServerSide rendering helper
 */
var MediaServerRender = defaultMedia.ServerRender;
var MediaConsumer = defaultMedia.Consumer;
/**
 * pickMatchHookAPI
 */
var useMedia = defaultMedia.useMedia;
export { createMediaMatcher, pickMatch, ProvideMediaMatchers, MediaMatches, InlineMediaMatcher, Above, Below, MediaMatcher, MediaServerRender, Matches, MediaMock, MediaConsumer, useMedia, };
