import { BoolOf, MediaRulesOf, ObjectOf } from './types';
export declare function forEachName<T, K, R = {
    [key in keyof T]: K;
}>(object: MediaRulesOf<T>, map: (key: string) => K): R;
export declare function getMaxMatch<T>(mediaRules: MediaRulesOf<T>, matches: Partial<BoolOf<any>>): string;
export declare function pickMediaMatch<T, K>(mediaRules: MediaRulesOf<T>, matches: Partial<BoolOf<any>>, slots: Partial<ObjectOf<any, K>>, defaultValue?: K): K | undefined;
export interface Names {
    [key: string]: any;
}
export declare function pickMatchValues(points: Names, props: Names): any;
export declare function inBetween(breakPoints: Names, points: any, value: any, invert: boolean, include: boolean): any;
export declare function nothingSet(matches: {
    [key: string]: any;
}): {
    [key: string]: boolean;
};
export declare function notNulls(matches: {
    [key: string]: boolean | undefined;
}): {
    [key: string]: boolean;
};
