"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createMediaMatcher_1 = require("./createMediaMatcher");
exports.createMediaMatcher = createMediaMatcher_1.createMediaMatcher;
var mediaDefaults_1 = require("./mediaDefaults");
var defaultMedia = createMediaMatcher_1.createMediaMatcher(mediaDefaults_1.default, 'mobile');
/**
 * Picks value from Slots for matching Match)
 * @type {<K>(matches: BoolOf<T>, slots: ObjectOf<T, K>) => K}
 */
var pickMatch = defaultMedia.pickMatch;
exports.pickMatch = pickMatch;
/**
 * Provides Context for underlying consumers
 * @type {SFC}
 */
var ProvideMediaMatchers = defaultMedia.Provider;
exports.ProvideMediaMatchers = ProvideMediaMatchers;
/**
 * Consumes provided information from context and returns via renderProps
 * @type {SFC<{children: RenderMatch<any>}>}
 */
var MediaMatches = defaultMedia.Matches;
exports.MediaMatches = MediaMatches;
/**
 * Calculates media match and renders a rule
 * @type {SFC<RenderOf<any>>}
 */
var InlineMediaMatcher = defaultMedia.Inline;
exports.InlineMediaMatcher = InlineMediaMatcher;
/**
 * Consumes provided information and renders matched rule
 * @type {SFC<RenderOf<any>>}
 */
var MediaMatcher = defaultMedia.Matcher;
exports.MediaMatcher = MediaMatcher;
/**
 * Calculates media match and returns via renderProps
 * @type {RPC<any, any>}
 */
var Matches = defaultMedia.Matches;
exports.Matches = Matches;
var MediaMock = defaultMedia.Mock;
exports.MediaMock = MediaMock;
/**
 * Renders only below specific break point
 */
var Below = defaultMedia.Below;
exports.Below = Below;
/**
 * Renders only above specific break point
 */
var Above = defaultMedia.Above;
exports.Above = Above;
/**
 * ServerSide rendering helper
 */
var MediaServerRender = defaultMedia.ServerRender;
exports.MediaServerRender = MediaServerRender;
var MediaConsumer = defaultMedia.Consumer;
exports.MediaConsumer = MediaConsumer;
/**
 * pickMatchHookAPI
 */
var useMedia = defaultMedia.useMedia;
exports.useMedia = useMedia;
